CKEDITOR.dialog.add( 'thumbDialog', function( editor ) {
	return {
		title : 'Thumbnail '+editor.lang.flash.propertiesTab,
		minWidth : 400,
		minHeight : 160,
		contents : [
			{
				id : 'general',
				label : 'Settings',
				elements : [
					{
						type : 'text',
						id : 'file_url',
						label : editor.lang.common.url,
						validate : CKEDITOR.dialog.validate.notEmpty( 'The link must have a URL.' ),
						required : true,
						setup: function( element ) {
                            this.setValue( element.getChild(0).getAttribute( "src" ) );
                        },
						commit : function( data ) {
							data.file_url = this.getValue();
						}
					},
					{
						id:'img_url',
						type:'text',
						hidden : true,
						label:editor.lang.image.url,accessKey:'A',
						'default':'',
						setup: function( element ) {
                            this.setValue( element.getAttribute( "href" ) );
                        },
						commit : function( data ) {
							data.img_url = this.getValue();
						}
					},
					{
					type: 'hbox',
					children: [
						{
							type: 'html',
							id: 'htmlPreview',
							html: '<div>' + CKEDITOR.tools.htmlEncode( editor.lang.common.preview ) + '<br>' +
							'<div class="ImagePreview" id="ImagePreviewBox" style="border: 2px ridge black;height: 80px;width: 80px;background-color: white;background-size:100% auto;"></div></div>',
							setup: function( element ) {
								CKEDITOR.document.getById( 'ImagePreviewBox' ).setStyle( 'background-image', 'url("'+element.getChild(0).getAttribute( "src" )+'")' );
							},
						},
						{
							type: 'select',
							id: 'img_option',
							label: 'Thumbnail type',
							items:[[editor.lang.common.notSet,'']],
							'default': '',
							onChange: function( api ) {
								var dialog = CKEDITOR.dialog.getCurrent();
								var element_id = CKEDITOR.document.getById( 'ImagePreviewBox' );
								var thumb_url = dialog.getContentElement( 'general', 'file_url' ).getValue();
								if(this.getValue() != '') {
									element_id.setStyle('background-image', 'url("'+thumb_url+'")');
									var thumb_name = thumb_url.substr(thumb_url.lastIndexOf("\/") + 1);
									dialog.setValueOf( 'general', 'file_url', thumb_url.replace(thumb_name, this.getValue()) );
								}
							},
							setup: function( element ) {
								var value;
								var dialog = CKEDITOR.dialog.getCurrent();
								var thumb_url = dialog.getContentElement( 'general', 'file_url' ).getValue();
								var thumb_name = thumb_url.substr(thumb_url.lastIndexOf("\/") + 1);
								var thumb_urls = dialog.getContentElement( 'general', 'img_url' ).getValue();
								var thumb_names = thumb_urls.substr(thumb_urls.lastIndexOf("\/") + 1);
								var thumb_full_path = thumb_url.substr(0, thumb_url.lastIndexOf("\/")+1);
								var thumb_path = thumb_full_path.substr(thumb_full_path.lastIndexOf("data")-1, thumb_full_path.lastIndexOf("\/")+1);
								$.post("../plugins/responsivefilemanager/fileList.php?path="+thumb_path+"&thumb="+thumb_names, function(data) {
									var obj = JSON.parse(data);
									dialog.getContentElement( 'general', 'img_option' ).clear();
									dialog.getContentElement( 'general', 'img_option' ).add(editor.lang.common.notSet,'');
									for (var i = 0; i < obj.length; i++) {
										for (var categoryid in obj[i]) {
											var category = obj[i][categoryid];
											if(categoryid == "name") {
												th_name = category;
											}
											if(categoryid == "dimensions") {
												th_dimen = category;
											}
										}
										if(obj.length < 2) {
											dialog.getContentElement( 'general', 'img_option' ).disable();
										} else {
											dialog.getContentElement( 'general', 'img_option' ).enable();
											dialog.getContentElement( 'general', 'img_option' ).add(th_dimen, th_name);
											if(th_name == thumb_name) {
												value = th_name;
											}
										}
									}
									valueIsReady(value);
								});
								function valueIsReady(value) {
									dialog.getContentElement( 'general', 'img_option' ).setValue( value );
								}
							},
							commit : function( data ) {
								data.img_Opt = this.getValue();
							}
						},
						{
							type : 'button',
							hidden : true,
							id : 'browse',
							style : 'position: absolute;right: 16px;',
							align : 'center',
							label : editor.lang.common.browseServer,
							filebrowser : {
							action : 'Browse',
							onSelect : function( fileUrl, data ) {
								var dialog = this.getDialog();
								dialog.getContentElement( 'general', 'file_url' ).setValue( fileUrl.replace("uploads", "thumbs") );
								dialog.getContentElement( 'general', 'img_url' ).setValue( fileUrl );
								var thumb_url = dialog.getContentElement( 'general', 'file_url' ).getValue();
								var thumb_name = thumb_url.substr(thumb_url.lastIndexOf("\/") + 1);
								var thumb_full_path = thumb_url.substr(0, thumb_url.lastIndexOf("\/")+1);
								var thumb_path = thumb_full_path.substr(thumb_full_path.lastIndexOf("data")-1, thumb_full_path.lastIndexOf("\/")+1);
								var element_id = CKEDITOR.document.getById( 'ImagePreviewBox' );
								element_id.setStyle('background-image', 'url("'+thumb_url+'")');
								$.post("../plugins/responsivefilemanager/fileList.php?path="+thumb_path+"&thumb="+thumb_name, function(data) {
									var obj = JSON.parse(data);
									dialog.getContentElement( 'general', 'img_option' ).clear();
									dialog.getContentElement( 'general', 'img_option' ).add(editor.lang.common.notSet,'');
									for (var i = 0; i < obj.length; i++) {
										for (var categoryid in obj[i]) {
											var category = obj[i][categoryid];
											if(categoryid == "name") {
												th_name = category;
											}
											if(categoryid == "dimensions") {
												th_dimen = category;
											}
										}
										if(obj.length < 2) {
											dialog.getContentElement( 'general', 'img_option' ).disable();
										} else {
											dialog.getContentElement( 'general', 'img_option' ).enable();
											dialog.getContentElement( 'general', 'img_option' ).add(th_dimen, th_name);
										}
									}
								});
								return false;
							}
							}
						}
					]
					},
					{
						id:'txtAlt',
						type:'text',
						label:editor.lang.image.alt,accessKey:'A',
						'default':'',
						setup: function( element ) {
                            this.setValue( element.getChild(0).getAttribute( "alt" ) );
                        },
						commit : function( data ) {
							data.txtAlt = this.getValue();
						}
					},
					{
					type:'hbox',
					children:[
						{
							type: 'select',
							id: 'img_Align',
							label: editor.lang.common.align,
							items:[[editor.lang.common.notSet,''], [editor.lang.common.alignLeft,'left'],[editor.lang.common.alignRight,'right']],
							setup: function( element ) {
								var value = element.getChild(0).getStyle( 'float' );
								this.setValue( value );
							},
							commit : function( data ) {
								data.img_Align = this.getValue();
							}
						},
						{
							type: 'select',
							id: 'img_loader',
							label: editor.lang.common.target,
							items:[[editor.lang.common.targetNew,'_blank'], [editor.lang.common.targetSelf,'_self'], ['prettyPhoto','prettyPhoto'], ['FancyBox','fancybox'], ['BaguetteBox','baguettebox']],
							'default':'prettyPhoto',
							onChange: function( api ) {
								var dialog = CKEDITOR.dialog.getCurrent();
								var element_id = dialog.getContentElement( 'general', 'baguette_settings' );
								if(this.getValue() == 'baguettebox') {
									element_id.getElement().show();
								}
								else {
									element_id.getElement().hide();
								}
							},
							setup: function( element ) {
								var value = element.getAttribute( "class" );
								var loader;
								if(element.getAttribute( "target" ) == '_blank') loader = '_blank';
								if(element.getAttribute( "target" ) == '_self') loader = '_self';
								if (value.indexOf("prettyPhoto") >= 0) loader = 'prettyPhoto';
								if (value.indexOf("fancybox") >= 0) loader = 'fancybox';
								if (value.indexOf("baguettebox") >= 0) loader = 'baguettebox';
								this.setValue( loader );
							},
							commit : function( data ) {
								data.img_loader = this.getValue();
							}
						},
						{
							id:'img_margins',
							type:'text',
							label:'Margins (px)',
							validate: CKEDITOR.dialog.validate.integer(editor.lang.common.validateNumberFailed),
							'default':'',
							setup: function( element ) {
								var value = element.getChild(0).getStyle( 'margin' );
								this.setValue( value.replace('px', '') );
							},
							commit : function( data ) {
								data.img_margins = this.getValue();
							}
						},
					]},
					{
						type:'hbox',
						id:'baguette_settings',
						hidden : true,
						children:[
							{
								type: 'checkbox',
								id: 'baguette_first',
								label: 'Start a new gallery',
								title: 'Check if this image is the first in the gallery',
								'default': false,
								commit : function( data ) {
									data.baguette_first = this.getValue();
								}
							},
					]},
				]
			}
		],
		onShow: function() {
            var selection = editor.getSelection();
            var element = selection.getStartElement();
            if ( element.getAscendant( 'a' ) !== null && element.getAscendant( 'a', true ).hasClass('thumbnail') ) {
                element = element.getAscendant( 'a', true );
				this.insertMode = false;
			}
            else
                this.insertMode = true;
				console.log("Insert Mode: "+this.insertMode);
            this.element = element;
            if ( !this.insertMode )
                this.setupContent( this.element );
			else
				CKEDITOR.document.getById( 'ImagePreviewBox' ).setStyle('background-image', 'none');
		},
		onOk : function() {
			var dialog = this, data = {}, reff = editor.document.createElement( 'a' ); 
			var thumb = this.element;
			var styles = 'border: 0 none;';
			this.commitContent( data );
			if(data.img_margins) {
				styles = styles + ' margin: '+data.img_margins+'px;';
			}
			reff.setAttribute('href', data.img_url);
			
			if(data.img_loader == '_blank' || data.img_loader == '_self') {
				reff.setAttribute('target', data.img_loader);
				reff.setAttribute('class', 'thumbnail');
			} else {
				reff.setAttribute('class', 'thumbnail '+data.img_loader+'Box');
				if(data.img_loader != 'baguettebox') {
					reff.setAttribute('rel', data.img_loader+'[myGallery]');
				}
			}
			if(data.img_Align == 'left' || data.img_Align == 'right') {
				styles = styles + ' float: '+data.img_Align+';';
			}
			if(data.baguette_first) {
				divf = editor.document.createElement( 'div' );
				divf.setAttribute('class', 'baguettebox');
				divf.setHtml( '<a href="'+data.img_url+'" class="thumbnail baguetteboxBox"><img class="'+data.img_loader+'Img" alt="'+data.txtAlt+'" src="'+data.file_url+'" style="'+styles+'" /></a>' );
				editor.insertElement( divf );
			}
			else {
				reff.setHtml( '<img class="'+data.img_loader+'Img" alt="'+data.txtAlt+'" src="'+data.file_url+'" style="'+styles+'" />' );
			}
			if ( !this.insertMode ) {
				$( ".thumbnail" ).remove();
			}
				editor.insertElement( reff );
		}
	};
});